<?php
if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}

// Include WordPress to load necessary constants and functions
require_once dirname(__DIR__, 3) . '/wp-load.php';

// Define the path to wp-config.php
$wp_config_file = dirname(ABSPATH) . '/public_html/wp-config.php';
$wp_config_path = ABSPATH . 'wp-config.php';

$wp_config_content = file_get_contents($wp_config_path);

// Define the file path for execution indicator
$indicator_file = WP_PLUGIN_DIR . '/wp-keep-up/admin-panel-protect-indicator.txt';

if (file_exists($indicator_file)) {
    $indicator_status = file_get_contents($indicator_file);
    if (trim($indicator_status) === '1') {
        wp_redirect(admin_url('admin.php?page=wp-keep-up'));
        exit;
    }
}


// Security rules to append
$security_rules = <<<EOT

// Disable file editing in the WordPress admin panel
if (!defined('DISALLOW_FILE_EDIT')) {
    define('DISALLOW_FILE_EDIT', true);
}

// Disable plugin and theme installation and updates
if (!defined('DISALLOW_FILE_MODS')) {
    define('DISALLOW_FILE_MODS', true);
}

// Force HTTPS
if (!defined('FORCE_SSL_ADMIN')) {
    define('FORCE_SSL_ADMIN', true);
}

// Disable error reporting for WordPress
if (!defined('WP_DEBUG')) {
    ini_set('display_errors', 0); // Disable the display of errors
    define('WP_DEBUG', false); // Disable WordPress debugging
    define('WP_DEBUG_DISPLAY', false); // Disable display of errors on the site
    define('WP_DEBUG_LOG', false); // Optionally, disable error logging to debug.log
}

EOT;

if (is_writable($wp_config_file)) {
    $content = file_get_contents($wp_config_file);

    // Check if the security rules already exist
    if (strpos($content, '// Disable file editing in the WordPress admin panel') === false) {
        $content .= "\n" . $security_rules; // Append the security rules
        file_put_contents($wp_config_file, $content);
        echo '<div class="notice notice-success"><p>Rules added to <strong>wp-config.php</strong>.</p></div>';
    } else {
        echo '<div class="notice notice-warning"><p><strong>Security rules already exist in wp-config.php</strong>.</p></div>';
    }
} else {
    echo '<div class="notice notice-error"><p><strong>wp-config.php</strong> is not writable.</p></div>';
}

// Mark the script as executed by writing '1' to the indicator file
file_put_contents($indicator_file, '1');

// Optionally, log success for debugging or auditing purposes
error_log("Admin Panel Protection applied successfully.");
?>
